---
title: Async scripts for asm.js
slug: Games/Techniques/Async_scripts
tags:
  - Games
  - JavaScript
  - asm.js
  - async
---
<div>{{GamesSidebar}}</div>

<div class="summary">
<p><span class="seoSummary">Every medium or large game should compile <a href="/en-US/docs/Games/Tools/asm.js">asm.js</a> code as part of an async script to give the browser the maximum flexibility to optimize the compilation process. In Gecko, async compilation allows the JavaScript engine to compile the asm.js off the main thread when the game is loading and cache the generated machine code so that the game doesn't need to be compiled on subsequent loads (starting in Firefox 28). To see the difference, toggle <code>javascript.options.parallel_parsing</code> in <code>about:config</code>.</span></p>
</div>

<h2 id="Putting_async_into_action">Putting async into action</h2>

<p>Getting async compilation is easy: when writing your JavaScript, just use the <code>async</code> attribute like so:</p>

<pre class="brush: js notranslate">&lt;script async src="file.js"&gt;&lt;/script&gt;</pre>

<p>or, to do the same thing via script:</p>

<pre class="brush: js notranslate">var script = document.createElement('script');
script.src = "file.js";
document.body.appendChild(script);</pre>

<p>(Scripts created from script default to <code>async</code>.) The default HTML shell Emscripten generates produces the latter.</p>

<h2 id="When_is_async_not_async">When is async not async?</h2>

<p>Two common situations in which a script is *not* async (as <a href="http://www.w3.org/TR/html5/scripting-1.html">defined by the HTML spec</a>) are:</p>

<pre class="brush: js notranslate">&lt;script async&gt;code&lt;/script&gt;</pre>

<p>and</p>

<pre class="brush: js notranslate">var script = document.createElement('script');
script.textContent = "code";
document.body.appendChild(script);</pre>

<p>Both are counted as 'inline' scripts and get compiled and then run immediately.</p>

<p>What if your code is in a JS string? Instead of using <code>eval</code> or <code>innerHTML</code>, both of which trigger synchronous compilation, you should use a Blob with an object URL:</p>

<pre class="brush: js notranslate">var blob = new Blob([codeString]);
var script = document.createElement('script');
var url = URL.createObjectURL(blob);
script.onload = script.onerror = function() { URL.revokeObjectURL(url); };
script.src = url;
document.body.appendChild(script);</pre>

<p>The setting of <code>src</code> rather than <code>innerHTML</code> is what makes this script async.</p>
